package net.sjava.cassandra;

import java.util.List;

import org.apache.log4j.Logger;

import net.sjava.cassandra.manager.CategoryManager;
import net.sjava.cassandra.manager.CommentManager;
import net.sjava.cassandra.manager.PostManager;
import net.sjava.cassandra.model.Category;
import net.sjava.cassandra.model.Comment;
import net.sjava.cassandra.model.Post;

/**
 * ī α ׽Ʈ ڵ 
 * 
 * @author mcsong@gmail.com
 */
public class CassandraBlogExample {
	private static final Logger LOG = Logger.getLogger(CassandraBlogExample.class);
	
	/**
	 * īװ ׽Ʈ Ѵ. 
	 * @throws Exception
	 */
	public static void testCategory() throws Exception {
		CategoryManager cManager = CategoryManager.instance();

		// īװ ߰Ѵ.
		long key = 1;
		int count = 5;
		for (int i = 1; i < count + 1; i++) {
			key = i;
			cManager.addCategory(String.valueOf(key), String.valueOf(key), String.valueOf(key) + "-° īװ");
		}
		
		// īװ Ʈ ȮѴ.
		List<Category> clist = null;
		clist = cManager.getCategoryies();
		for (int i = 0; i < clist.size(); i++)
			LOG.debug(clist.get(i).toString());

		// īװ Ѵ.
		cManager.deleteCategory("4");

		// īװ Ʈ ȮѴ.
		clist = cManager.getCategoryies();
		for (int i = 0; i < clist.size(); i++)
			LOG.debug(clist.get(i).toString());
	}
	
	
	/**
	 * Ʈ ׽ƮѴ. 
	 * 
	 * @throws Exception
	 */
	public static void testPost() throws Exception {		
		PostManager pManager = PostManager.instance();
		
		// 1 īװ ͸ Ѵ. 
		int count = 1000;
		for(int i=0; i < count; i++)	 {
			pManager.addPost(System.currentTimeMillis(),  i + "-ŸƲ1111111", i + "-~~ Ʈ .. ", "1");
			Thread.sleep(50);
		}
		
		// 2 īװ ͸ Ѵ.  
		count = 6;
		for(int i=0; i < count; i++) {
			pManager.addPost(System.currentTimeMillis(), i + "-ŸƲ2222222", i + "-~~ Ʈ .. ", "2");
			Thread.sleep(50);
		}
		
		List<Post> posts = null;
		
		// Ʈ ü Ű εѴ. 
		pManager.prepare();
		posts = pManager.getPosts(10, 1);
		
		for(int i=0; i < posts.size(); i++)
			LOG.debug(posts.get(i).toString());
		
		System.out.println("---------------------------------------------");
		
		// īװ Ű εѴ. 
		//pManager.prepareWithCategory("1");
		pManager.prepareWithCategory("2");
		posts = pManager.getPosts(10, 1);
		
		for(int i=0; i < posts.size(); i++)
			LOG.debug(posts.get(i).toString());
		
		
		// Ʈ Ѵ. 
		pManager.deletePost(Long.parseLong("1310307855625"));
		
		pManager.prepareWithCategory("2");
		posts = pManager.getPosts(10, 1);
		
		for(int i=0; i < posts.size(); i++)
			LOG.debug(posts.get(i).toString());
	}
	
	
	/**
	 *  ׽Ʈ Ѵ. 
	 * 
	 * @throws Exception
	 */
	public static void testComment() throws Exception {
		// Ʈ  Ʈ  ؼ PostManager ü Ѵ. 
		PostManager pManager = PostManager.instance();
		pManager.prepareWithCategory("1");
		List<Post> posts = pManager.getPosts(5, 1);
		
		// Ʒ Ʈ 뿡  ֱ ؼ  CommentManager ü Ѵ. 
		CommentManager coManager = CommentManager.instance();
		
		for(int i=0; i < posts.size(); i++) {
			LOG.debug(posts.get(i).toString());
			//List<Comment>  comments =  coManager.getComments(String.valueOf(posts.get(i).getId()));
			// ش Ʈ   ش. 
			//if( comments.size() > 0 ) {
			//	for(int x=0; x <  comments.size(); x++)
			//		LOG.debug(comments.get(x).toString());
			//}
		}
		
		// Comment Post id Բ Ѵ. 
		//coManager.addComment(System.currentTimeMillis(), "1310307807640", "1310307807640 Ʈ  ڸƮ......... ");
		//coManager.addComment(System.currentTimeMillis(), "1310307807640", "1310307807640 Ʈ  ڸƮ222... ");
		
		List<Comment> lists = coManager.getComments("1310307807640");
		for(int i=0; i < lists.size(); i++)
			LOG.debug(lists.get(i).toString());
		
		// Comment key  Ѵ. 
		coManager.deleteComment(Long.parseLong("1310309569031"));
		lists = coManager.getComments("1310307807640");
		for(int i=0; i < lists.size(); i++)
			LOG.debug(lists.get(i).toString());
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		// īװ ׽Ʈ Ѵ. 
		//testCategory();
		
		// Ʈ ׽Ʈ Ѵ. 
		//testPost();
		
		//  ׽Ʈ Ѵ. 
		//testComment();
	}

}
